#!/usr/bin/perl

#
# verifico i parametri di input
#
if (@ARGV != 2) {
	print "\nHELP: $0 SERVERDIR FILENAME\n\n";
	exit -1;
}
$servername=$ARGV[0];
$filename=$ARGV[1];

#
# verifico se la cartella del server esiste
#
if ( ! -d $servername ) {
	print "\nIl server '$servername' non esiste\n\n";
	exit -1;
}

#
# verifico che il file esiste (cioè viene "distribuito" dal server)
# da notare l'espressione regolare del grep
#
$offset=0;
$info = `cat $servername/config.txt | grep -E "^$filename [0-9]+ .+([0-9]+,$offset)"`;
print "Il file: $info \n";
if (! $info) {
	print "Il file '$filename' non è presente sul server\n";
	exit 0;
}

$complete=0;
while(! $complete){
	$info =~ /^$filename ([0-9]+) (.+)\(([0-9]+),$offset\)/;
	$dimfile=$1;
	$username=$2;
	$dimpart=$3;
	`cat $servername/$username/$filename.part >> $filename`;
	$offset = $offset + $dimpart;
	if ($offset == $dimfile) {
		$complete=1;
	}
	else {
		$info = `cat $ARGV[0]/config.txt | grep -E "^$ARGV[1] [0-9]+ .+([0-9]+,$offset)"`;
	}
}

