#!/usr/bin/perl

#
# verifico i parametri di input
#
if (@ARGV != 1) {
	print "\nHELP: $0 SERVERDIR \n\n";
	exit -1;
}
$servername=$ARGV[0];

#
# verifico se la cartella del server esiste
#
if ( ! -d $servername ) {
	print "\nIl server '$servername' non esiste\n\n";
	exit -1;
}

open (CONF,"$servername/config.txt") || die "Il file '$servername/config.txt' non esiste";

foreach (<CONF>) {
	#
	# Tralascio le righe che non corrispondono al formato
	#
	next if ( ! /^(.+) ([0-9]+) (.+)\(([0-9]+),([0-9]+)\)/ );
	
	$filename=$1;
	$dimfile=$2;
	$username=$3;
	$dimpart=$4;
	$offset=$5;
	
	#
	# Verifico l'esistenza del file di dimensione corretta
	#
	if ( `wc -c $servername/$filename 2> /dev/null` != $dimfile ) {
		print "Il file '$servername/$filename' non esiste o non e' di dimensione corretta\n" ;
		next;
	}
	
	#
	# Creo la directory dell'utente
	#
	if ( ! -d "$servername/$username" ) {
		`mkdir $servername/$username`;
	}
	
	#
	# Creo i file '.part': 
	# - con 'tail -c +N nomefile' ottengo il contenuto del file a partire dal byte N
	# - con '| head -c N' ottengo i primi N byte dell'output di tail
	# - con '> nomefile' memorizzo l'output di head su un file
	#
	$offset=$offset+1;
	`tail -c +$offset $servername/$filename | head -c $dimpart > $servername/$username/$filename.part`;
}


close (CONF);
